
<!DOCTYPE html>
<html>
  <head>
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>RTT-FSBALBUENA</title>
    <!--ICON-->
     <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.8.1/css/all.css" integrity="sha384-50oBUHEmvpQ+1lW4y57PTFmhCaXp0ML5d60M1M7uH2+nqUivzIebhndOJK28anvf" crossorigin="anonymous">
   <!--GOOGLE FONT-->
     <link href="https://fonts.googleapis.com/css?family=Abel&display=swap" rel="stylesheet">
     <link rel="stylesheet" href="style.css">
    <!--React-->
    <script crossorigin src="https://unpkg.com/react@16/umd/react.production.min.js"></script>
    <!--ReactDom-->
<script crossorigin src="https://unpkg.com/react-dom@16/umd/react-dom.production.min.js"></script>
  </head>
  <body>
        <a href="https://linkedin.com/in/fsbalbuena/" id="fsbalbuena">FSBalbuena</a>  
    <main id="main"></main>
    <script src="https://unpkg.com/babel-standalone@6/babel.min.js"></script>
    <script type="text/babel">
    
//----------------------------------------------------------------
//---------COMPONENTS-------------------------------------------------------
const Title=({text,id})=>(<p id={id} className="title">{text}</p>)
const Button=({icon,id,handleClick})=>(<span id={id} className="button" onClick={handleClick}><i className={icon}></i></span>)
const Display=({text,id})=>(<p id={id} className="display">{text}</p>)

//----------------------------------------------------------------
//---------CONTAINERS-------------------------------------------------------
class BreakContainer extends React.Component{
    constructor(props){
        super(props)
        
    }
    
    render(){
        const {handleClick,time}=this.props
        return(<div id="break" className="containers">
        <Title text="Break Length" id="break-label"/>
        <Button icon="fas fa-sort-down" id="break-decrement" handleClick={()=>handleClick("breakTime",false)}/>
        <Display text={time} id="break-length"/>
        <Button icon="fas fa-sort-up" id="break-increment" handleClick={()=>handleClick("breakTime",true)}/>

        </div>)
    }
}
class SessionContainer extends React.Component{
    constructor(props){
        super(props)
    }
    
    render(){
        const {handleClick,time}=this.props

        return(<div id="session" className="containers">
         <Title text="Session Length" id="session-label"/>
        <Button icon="fas fa-sort-down" id="session-decrement" handleClick={()=>handleClick("sessionTime",false)}/>
        <Display text={time} id="session-length"/>
        <Button icon="fas fa-sort-up" id="session-increment" handleClick={()=>handleClick("sessionTime",true)}/>
        </div>)
    }
}
class ClockContainer extends React.Component{
    constructor(props){
        super(props)
        this.state={}
    }
    render(){
        const {handleReset,time,handlePlayPause,currentModule}=this.props
        return(<div id="clock" className="containers">
         <Title text={currentModule} id="timer-label"/>
        <Button icon="far fa-play-circle" id="start_stop" handleClick={handlePlayPause}/>
        <Display text={time} id="time-left"/>
        <Button icon="far fa-pause-circle" id="reset" handleClick={handleReset}/>
        </div>)
    }
}

//----------------------------------------------------------------
//---------EXECUTE-------------------------------------------------------

class Main extends React.Component{
    constructor(props){
        super(props)
        this.state={
            currentModule:"session",
            currentTime:1500,
            isActive:false,
            sessionTime:25,
            breakTime:5,
            interval:null,
            audio:'https://www.w3docs.com/build/audios/audio.mp3'
        }
        this.handleTimes=this.handleTimes.bind(this)
        this.handleReset=this.handleReset.bind(this)
        this.handlePlay=this.handlePlay.bind(this)
        this.handlePause=this.handlePause.bind(this)
        this.handlePlayPause=this.handlePlayPause.bind(this)

    }
  
    handleTimes(time,sum){
        let val=this.state[time]
        if(sum && val<60){
            val++
        }if(!sum && val>1){
            val--
        }
        if(time==(this.state.currentModule+"Time")){
            this.handlePause()
            this.setState({[time]:val,currentTime:val*60})
            
        }else{

            this.setState({[time]:val})
        }
    }
    handleReset(){
  let audio=document.getElementById("beep")
  audio.pause()
  audio.currentTime=0
        this.handlePause()
        this.setState({
        currentModule:"session",
        currentTime:1500,
        sessionTime:25,
        breakTime:5})
    }
    handlePlay(){

        let interval=setInterval(function(){
            let time=this.state.currentTime
            if(time>0){
                this.setState({currentTime:time-1})
            }
            else{
                document.getElementById("beep").play()
                let newModule=this.state.currentModule=="session"?"break":"session"
                let name=newModule+"Time"
                this.setState(state=>({currentTime:state[name]*60,currentModule:newModule}))
            }
        }.bind(this),1000)
        this.setState({isActive:true,interval:interval})
    }

    handlePause(){
        document.getElementById("beep").pause()
        clearInterval(this.state.interval)
        this.setState({isActive:false,interval:null})
    }
    handlePlayPause(){
        this.state.isActive?this.handlePause():this.handlePlay()
    }
    render(){
        const {sessionTime,audio,breakTime,currentTime,currentModule}=this.state
        let min= parseInt(currentTime/60)
        let seg= currentTime%60     
        let time=(min<10?"0"+min:min)+":"+(seg<10?"0"+seg:seg)
        return (<div id="app">
                <BreakContainer handleClick={this.handleTimes} time={breakTime}/>
                <ClockContainer time={time} currentModule={currentModule} handleReset={this.handleReset} handlePlayPause={this.handlePlayPause}/>
            <SessionContainer handleClick={this.handleTimes} time={sessionTime}/>
                <audio id="beep" src={audio} preload="auto"/>
                </div>)
    }
}

ReactDOM.render(<Main/>,document.getElementById("main"))
    </script>
  </body>
</html>